;generic algorithms for containers like vector and string

(define (get-containter-ops obj)
  (cond ((string? obj) (values string-length string-ref string-set!))
        ((vector? obj) (values vector-length vector-ref vector-set!))))

(define (container-replace! cont rep-cont start)
  (receive (length elt-ref elt-set!)
          (get-containter-ops cont)
          (let ((rep-len (length rep-cont))
	        (len (length cont)))
            (let loop ((start start)
                       (rep-start 0))
              (or (>= rep-start rep-len)
                  (>= start len)
                  (begin (elt-set! cont
                                   start
                                   (elt-ref rep-cont rep-start))
                         (loop (+ start 1)
                               (+ rep-start 1))))))))

